/**************************************************************

File Name:		Matrix_test.asm
		
Date Modified:	05/22/00		GJO
				05/25/00		GJO	Code verified on rev 0.1 Silicon
				09/19/04		JDT Ported to VDSP++ 3.5. replace .SECTION syntax
				
Description:	ADSP-21364 multichannel SIMD program to call Matrix.asm.
				The input matrices, a and b, and output matrix, c, are 
				interleaved.

**************************************************************/

#include "def21364.h"

#define		N 4			/* matrix dimension constants */
#define		M 4

.EXTERN mxnxnx1;

.SECTION/DM seg_dmda;
.VAR			mat_a[2*M*N] = "mat_a4x4.dat";		/* data for matrix a=[MxN] */
.VAR			mat_c[2*M];							/* initialize matrix c=[Mx1] */


.SECTION/PM seg_pmda;
.VAR			mat_b[2*N]="mat_b4x4.dat";			/* data for matrix b=[Nx1] */


.SECTION/PM	seg_rth;
Reserved_1:		rti; nop; nop; nop;
Chip_Reset:		idle; jump start; nop; nop;


/* Calling code */		
.SECTION/PM seg_pmco;
start:		bit set mode1 CBUFEN;		/* Enable circular buffering */
		m0=M;		/* Setup matrix dimensions */
		m8=N;
		m1=2;		/* Setup address increment registers */
		m9=m1;				
		b0=mat_a;	l0=@mat_a;	/* Initialize pointers and cicular buffers */
		b1=mat_c;	l1=0;
		call mxnxnx1 (db);		/* Call matrix multiply function */
		b8=mat_b;	l8=@mat_b;	/* Initialize matrix b pointer and circular buffer */
wait1:		idle;
			nop;
